//  XPCOM          

var vk_js_loader;

const vk_js_files =
[
    "chrome://vkontaktetoolbar/content/global/vk_observer_service.js",
    "chrome://vkontaktetoolbar/content/global/vk_test.js",
    "chrome://vkontaktetoolbar/content/global/vk_info.js",
    "chrome://vkontaktetoolbar/content/global/vk_state.js",
    "chrome://vkontaktetoolbar/content/global/vk_prefs.js",
    "chrome://vkontaktetoolbar/content/global/vk_html_provider.js",
    "chrome://vkontaktetoolbar/content/global/vk_request_queue.js",
    "chrome://vkontaktetoolbar/content/global/vk_json.js",
    "chrome://vkontaktetoolbar/content/global/vk_dom_parser.js",
    "chrome://vkontaktetoolbar/content/global/vk_html_parser.js",
    "chrome://vkontaktetoolbar/content/global/vk_feed2.js",
    "chrome://vkontaktetoolbar/content/global/vk_global.js",
    "chrome://vkontaktetoolbar/content/global/vk_common.js"
];

vk_js_loader = Components.classes[ "@mozilla.org/moz/jssubscript-loader;1" ]
    .getService( Components.interfaces.mozIJSSubScriptLoader );

for ( var i = 0, elem; elem = vk_js_files[i]; i++ )
{
    vk_js_loader.loadSubScript( elem );
}

vk_js_loader = undefined;

//
// constants
//

// reference to the required base interface that all components must support
const nsISupports = Components.interfaces.nsISupports;

// UUID uniquely identifying our component
const CLASS_ID = Components.ID( "{242C4160-D92E-4013-8704-0AC848C27F5E}" );

// textual unique identifier
const CONTRACT_ID = "@uh-zuh/vkontakte-toolbar-global;1";

//

var vk_global = new vk_Global();

//
// class factory
//

var VkontakteToolbarGlobalFactory =
{
    createInstance: function( Outer, IID )
    {
        if ( Outer != null )
            throw Components.results.NS_ERROR_NO_AGGREGATION;
        return ( vk_global );
    }
};



//
// module definition (xpcom registration)
//

var VkontakteToolbarGlobalModule =
{
    registerSelf: function( CompMgr, FileSpec, Location, Type )
    {
        CompMgr = CompMgr.QueryInterface( Components.interfaces.nsIComponentRegistrar );
        CompMgr.registerFactoryLocation( CLASS_ID, null, CONTRACT_ID, FileSpec, Location, Type );
    },

    unregisterSelf: function( CompMgr, Location, Type )
    {
        CompMgr = CompMgr.QueryInterface( Components.interfaces.nsIComponentRegistrar );
        CompMgr.unregisterFactoryLocation( CLASS_ID, Location );
    },

    getClassObject: function( CompMgr, CID, IID )
    {
        if ( !IID.equals( Components.interfaces.nsIFactory ) )
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

        if ( CID.equals( CLASS_ID ) )
            return VkontakteToolbarGlobalFactory;

        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    canUnload: function( CompMgr )
    {
        return true;
    }
};



//
// module initialization
//
// When the application registers the component, this function is called.
//

function NSGetModule( CompMgr,  FileSpec )
{
    return VkontakteToolbarGlobalModule;
}

function NSGetFactory() {
  return VkontakteToolbarGlobalFactory;
}